//=============================================================================
// GaugeAmmunition.
// Created on: 26.04.2006 13:49:00
// Written by Eduard Klemens
// Mail to: madjackal_x@hotmail.com.
//  2006, MaD Inc. All Rights Reserved.
//=============================================================================
class AW7EDGaugeAmmunition extends P2AmmoInv;

var travel int CatAmmoLeft;		// How many shots we've taken with the cat, when this reaches
								// 0, the cat shoots off
var int ShotsWithCat;			// total shots we get with a cat, probably 9 for 9 lives
var class<DamageType> BodyDamage;
var class<DamageType> HeadDamage;
var class<DamageType> NonPawnDamage;

var float FleshRad;
var Sound FleshHit[4];

///////////////////////////////////////////////////////////////////////////////
// Process a trace hitting something
///////////////////////////////////////////////////////////////////////////////
function ProcessTraceHit(Weapon W, Actor Other, Vector HitLocation, Vector HitNormal, Vector X, Vector Y, Vector Z)
{
	local Rotator NewRot;
	local float PercentUpBody;

	if ( Other == None )
		return;

	if (Other.bStatic)//Other.bWorldGeometry )
	{
		spawn(class'EDGenericHitPack',W.Owner, ,HitLocation, Rotator(HitNormal));
		spawn(class'MaDBulletHitPack',W.Owner, ,HitLocation, Rotator(HitNormal));
	}
	else
	{

		// smash people and things with the sledge
		if(PeoplePart(Other) != None)
		{
			if (Head(Other) != None)
				Other.TakeDamage(DamageAmount, Pawn(Owner), HitLocation, MomentumHitMag*X, HeadDamage);
			else
				Other.TakeDamage(DamageAmount, Pawn(Owner), HitLocation, MomentumHitMag*X, DamageTypeInflicted);
		}
		else
		{
			if(FPSPawn(Other) == None
				|| HurtingAttacker(FPSPawn(Other)))
			{
				PercentUpBody = (HitLocation.Z - Other.Location.Z) / Other.CollisionHeight;

				// If it's a headshot, explode the head
				If (P2MoCapPawn(Other) != None
					&& P2Pawn(Other).bHasHead
					&& P2Pawn(Other).bHeadCanComeOff
					&& P2MoCapPawn(Other).MyHead != None
					&& PercentUpBody > P2Pawn(Other).HEAD_RATIO_OF_FULL_HEIGHT)
				{
				// Kamek comment this out because it's causing the player to lose his head and not die.
				// ShotgunDamage should explode heads properly
/*
					if (AWZombie(Other) == None)
					{
						// knock off the head
						P2MocapPawn(Other).ExplodeHead(HitLocation, MomentumHitMag*X);

						// set damage = life
						if (Pawn(Other).Health > 0)
							DamageAmount = Pawn(Other).Health;
						Other.TakeDamage(DamageAmount, Pawn(Owner), HitLocation, MomentumHitMag*X, DamageTypeInflicted);
					}
					else
					{
						Other.TakeDamage(DamageAmount, Pawn(Owner), HitLocation, MomentumHitMag*X, HeadDamage);
					}
*/
					Other.TakeDamage(DamageAmount, Pawn(Owner), HitLocation, MomentumHitMag*X, HeadDamage);
				}
				else if (Pawn(Other) != None)
					Other.TakeDamage(DamageAmount, Pawn(Owner), HitLocation, MomentumHitMag*X, DamageTypeInflicted);
				else
					Other.TakeDamage(DamageAmount, Pawn(Owner), HitLocation, MomentumHitMag*X, NonPawnDamage);
			}
		}

		if((Pawn(Other) != None && Other != Owner)
			|| PeoplePart(Other) != None
			|| CowheadProjectile(Other) != None)
		{
			if(Rand(2) == 0)
				Other.PlaySound(FleshHit[Rand(ArrayCount(FleshHit))],SLOT_Pain,,,FleshRad,GetRandPitch());
				spawn(class'EDSplatterPack',W.Owner, ,HitLocation,Rotator(HitNormal));
		}
		else // anything else--make a spark hit
		{
			spawn(class'EDGenericHitPack',W.Owner, ,HitLocation, Rotator(HitNormal));
			spawn(class'MaDBulletHitPack',W.Owner, ,HitLocation, Rotator(HitNormal));
		}
	}
}

//===========================================================================
// DefaultProperties
//===========================================================================

defaultproperties
{
     HeadDamage=Class'BaseFX.ShotGunDamage'
     NonPawnDamage=Class'BaseFX.BulletDamage'
     FleshRad=200.000000
     FleshHit(0)=Sound'WeaponSounds.bullet_hitflesh1'
     FleshHit(1)=Sound'WeaponSounds.bullet_hitflesh2'
     FleshHit(2)=Sound'WeaponSounds.bullet_hitflesh3'
     FleshHit(3)=Sound'WeaponSounds.bullet_hitflesh4'
     DamageAmount=20.000000
     MomentumHitMag=40000.000000
     DamageTypeInflicted=Class'MaD_EDDamage.GaugeDamage'
     DamageAmountMP=11.000000
     MaxAmmoMP=250
     MaxAmmo=500
     bLeadTarget=True
     bInstantHit=True
     WarnTargetPct=0.200000
     RefireRate=0.990000
     PickupClass=Class'MaD_ED.GaugeAmmoPickup'
}
