//=============================================================================
// NineAmmunition.
// Created on: 26.04.2006 13:49:00
// Written by Eduard Klemens
// Mail to: madjackal_x@hotmail.com.
// 2006, MaD Inc. All Rights Reserved.
//=============================================================================
class AW7EDNineAmmoInv extends P2AmmoInv;

var() class<DamageType> GlockDamage;
var() class<DamageType> AkimboDamage;
var() class<DamageType> MP5Damage;
var() class<DamageType> IngramDamage;
var() class<DamageType> BerettaDamage;
var() class<DamageType> ZombieHeadDamage;

const FLESH_HIT_MAX	=	4;
var Sound FleshHit[FLESH_HIT_MAX];
var float FleshRad;

///////////////////////////////////////////////////////////////////////////////
// Process a trace hitting something
///////////////////////////////////////////////////////////////////////////////
function ProcessTraceHit(Weapon W, Actor Other, Vector HitLocation, Vector HitNormal, Vector X, Vector Y, Vector Z)
{
	local Rotator NewRot;
	local class<DamageType> ThisDamage;

	// reduce the ammo
	UseAmmoForShot();

	if ( Other == None )
		return;

	// Have to use IsA thanks to crummy compile order concerns
	if (W.IsA('AW7EDGSelectWeapon'))
		ThisDamage = GlockDamage;
	else if (W.IsA('AW7EDGlockAkimboWeapon'))
		ThisDamage = AkimboDamage;
	else if (W.IsA('AW7EDMP5Weapon'))
		ThisDamage = MP5Damage;
	else if (W.IsA('AW7EDIngramWeapon'))
		ThisDamage = IngramDamage;
	else if (W.IsA('AW7EDBerettaWeapon'))
		ThisDamage = BerettaDamage;
	else
		ThisDamage = DamageTypeInflicted;
		
	if (ZombieHead(Other) != None)
		ThisDamage = ZombieHeadDamage;

	if (Other.bStatic)//Other.bWorldGeometry )
	{
		spawn(class'EDGenericHitPack',Owner, ,HitLocation, Rotator(HitNormal));
		spawn(class'MaDBulletHitPack',Owner, ,HitLocation, Rotator(HitNormal));
	}
	else
	{
		Other.TakeDamage(DamageAmount, Pawn(Owner), HitLocation, MomentumHitMag*X, ThisDamage);

		if((Pawn(Other) != None
				&& Other != Owner)
			|| PeoplePart(Other) != None
			|| CowheadProjectile(Other) != None)
		{
			Other.PlaySound(FleshHit[Rand(ArrayCount(FleshHit))],SLOT_Pain,,,FleshRad,GetRandPitch());
				spawn(class'EDSplatterPack',Owner, ,HitLocation,Rotator(HitNormal));
		}
		else // anything else--make a spark hit
		{
			spawn(class'EDGenericHitPack',Owner, ,HitLocation, Rotator(HitNormal));
			spawn(class'MaDBulletHitPack',Owner, ,HitLocation, Rotator(HitNormal));
		}
	}
}

///////////////////////////////////////////////////////////////////////////////
// Add in the instigator
///////////////////////////////////////////////////////////////////////////////
function SpawnNineProjectile(vector Start, vector Dir)
{
	local NineProjectile np;

	AmmoAmount -= 1;
	np = NineProjectile(spawn(ProjectileClass,Instigator,, Start));
	np.SetVelocity(Dir);
	//log(self$" spawned nine proj "$rp$" at "$np.Location$" player loc "$Instigator.Location$" speed "$np.Velocity$" rot "$Instigator.Rotation);



}

//===========================================================================
// DefaultProperties
//===========================================================================

defaultproperties
{
     GlockDamage=Class'AW7EDDamage.AW7EDGlockDamage'
     AkimboDamage=Class'AW7EDDamage.AW7EDAkimboDamage'
     MP5Damage=Class'AW7EDDamage.AW7EDMP5Damage'
     IngramDamage=Class'AW7EDDamage.AW7EDIngramDamage'
     BerettaDamage=Class'AW7EDDamage.AW7EDBerettaDamage'
     ZombieHeadDamage=Class'AWEffects.SledgeDamage'
     FleshHit(0)=Sound'ed_moresounds.Body.hit1'
     FleshHit(1)=Sound'ed_moresounds.Body.hit2'
     FleshHit(2)=Sound'ed_moresounds.Body.hit3'
     FleshHit(3)=Sound'ed_moresounds.Body.hit4'
     FleshRad=200.000000
     DamageAmount=18.000000
     MomentumHitMag=10000.000000
     AltDamageTypeInflicted=Class'AW7EDDamage.AW7EDNineDamage'
     MaxAmmoMP=500
     MaxAmmo=1000
     bLeadTarget=True
     bInstantHit=True
     ProjectileClass=Class'AW7EDAmmo.AW7EDNineProjectile'
     WarnTargetPct=0.200000
     RefireRate=0.990000
     PickupClass=Class'AW7EDAmmo.AW7EDNineAmmoPickup'
}
