class BerettaAmmoInv extends P2AmmoInv;

const FLESH_HIT_MAX	=	4;
var Sound FleshHit[FLESH_HIT_MAX];
var float FleshRad;

const HEAD_MOVE_Z_UP_BIG_TEMP_VARIABLE	=	5;
const EASY_HEAD_HIT						=	1.5;
const ADJUST_RELATIVE_HEAD_Z			=	-0.8;

const HEAD_RATIO_OF_FULL_HEIGHT	=	0.5;


///////////////////////////////////////////////////////////////////////////////
// Process a trace hitting something
///////////////////////////////////////////////////////////////////////////////
function ProcessTraceHit(Weapon W, Actor Other, Vector HitLocation, Vector HitNormal, Vector X, Vector Y, Vector Z)
{
	local Rotator NewRot;
	local float PercentUpBody, ZDist, DistToMe;
	local float userad;

	// reduce the ammo
	UseAmmoForShot();

	if ( Other == None )
		return;


	if (Other.bStatic)//Other.bWorldGeometry )
	{
		spawn(class'EDGenericHitPack',Owner, ,HitLocation, Rotator(HitNormal));
		spawn(class'MaDBulletHitPack',Owner, ,HitLocation, Rotator(HitNormal));
	}
	else
	{
		Other.TakeDamage(DamageAmount, Pawn(Owner), HitLocation, MomentumHitMag*X, DamageTypeInflicted);

		if((Pawn(Other) != None
				&& Other != Owner)
			|| PeoplePart(Other) != None
			|| CowheadProjectile(Other) != None)
		{
			Other.PlaySound(FleshHit[Rand(ArrayCount(FleshHit))],SLOT_Pain,,,FleshRad,GetRandPitch());
				spawn(class'EDSplatterPack',Owner, ,HitLocation,Rotator(HitNormal));
		}
		else // anything else--make a spark hit
		{
			spawn(class'EDGenericHitPack',Owner, ,HitLocation, Rotator(HitNormal));
			spawn(class'MaDBulletHitPack',Owner, ,HitLocation, Rotator(HitNormal));
		}
	}

	if(P2MocapPawn(Other).MyHead == None)
			return;

	if(P2MocapPawn(Other).MyHead != None)
		{
		userad = EASY_HEAD_HIT*P2MocapPawn(Other).MyHead.CollisionHeight;
		}
	else
		{
		userad = P2MocapPawn(Other).MyHead.CollisionHeight;
		}

	ZDist = HitLocation.z - (P2MocapPawn(Other).MyHead.Location.z + HEAD_MOVE_Z_UP_BIG_TEMP_VARIABLE);


	if(ZDist > -userad)
		{
			Other.TakeDamage(200, Pawn(Owner), HitLocation, MomentumHitMag*X, Class'AWEffects.SledgeDamage');
		}
	else
		return;

}

///////////////////////////////////////////////////////////////////////////////
// Add in the instigator
///////////////////////////////////////////////////////////////////////////////
function SpawnNineProjectile(vector Start, vector Dir)
{
	local NineProjectile np;

	AmmoAmount -= 1;
	np = NineProjectile(spawn(ProjectileClass,Instigator,, Start));
	np.SetVelocity(Dir);
	//log(self$" spawned nine proj "$rp$" at "$np.Location$" player loc "$Instigator.Location$" speed "$np.Velocity$" rot "$Instigator.Rotation);

}


//===========================================================================
// DefaultProperties
//===========================================================================

defaultproperties
{
     Texture=Texture'ED_Hud.HUDberetta'
     FleshHit(0)=Sound'ed_moresounds.Body.hit1'
     FleshHit(1)=Sound'ed_moresounds.Body.hit2'
     FleshHit(2)=Sound'ed_moresounds.Body.hit3'
     FleshHit(3)=Sound'ed_moresounds.Body.hit4'
     FleshRad=200.000000
     DamageAmount=18.000000
     MomentumHitMag=10000.000000
     DamageTypeInflicted=Class'AW7EDDamage.AW7EDNineDamage'
     AltDamageTypeInflicted=Class'AW7EDDamage.AW7EDNineDamage'
     MaxAmmoMP=500
     MaxAmmo=1000
     bLeadTarget=True
     bInstantHit=True
     ProjectileClass=Class'AW7EDAmmo.AW7EDNineProjectile'
     WarnTargetPct=0.200000
     RefireRate=0.990000
     PickupClass=Class'AW7EDAmmo.AW7EDNineAmmoPickup'
}
